MSFROP(1)

NAME
msfrop - ROP-Chain or Gadget Finder

SYNOPSIS
msfrop <option> [targets]

OPTIONS

-d, --depth [size]
    Number of maximum bytes to backwards disassemble from return instructions

-s, --search [regex]
    Search for gadgets matching a regex, match intel syntax or raw bytes

-n, --nocolor
    Disable color. Useful for piping to other tools like the less and more commands

-x, --export [filename]
    Export gadgets to CSV format

-i, --import [filename]
    Import gadgets from previous collections

-v, --verbose
    Output very verbosely

-h, --help
    Show this message

DESCRIPTION
A ROP payload in created by using pre-existing sets of instructions from non-ASLR enabled binaries to make your shellcode executable. Each set of instructions needs to end in a RETN instruction to carry on the ROP-chain with each set of instructions commonly referred to as a gadget. The msfrop tool in Metasploit will search a given binary and return the usable gadgets.

EXEMPLE
msfrop -v metsrv.dll
msfrop -x metsrv_gadgets metsrv.dll

SEE ALSO
msfpescan(1)
msfelfscan(1)

AUTHORS

Creator
    HD Moore - @hdmoore / hdm@metasploit.com

COPYRIGHT
Copyright (C) 2006-2013, Rapid7 Inc. All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

*   Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

*   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

*   Neither the name of Rapid7 LLC nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. The Metasploit Framework is provided under the 3-clause BSD license above. The copyright on this package is held by Rapid7 LLC. This license does not apply to several components within the Metasploit Framework source tree. For more details see the LICENSE file.